-------------------------------------------
--- AddOn: Ketho CombatLog				---
--- Author: Ketho (EU-Boulderfist)		---
--- Created: 2009.09.01					---
--- License: Public Domain				---
-------------------------------------------
--- Ketho CombatLog	v0.95 [2011.05.26]	---
--- Ace3 Framework	r1025 [2011.04.27]	---
-------------------------------------------
--- Curse			http://wow.curse.com/downloads/wow-addons/details/ketho-combatlog.aspx
--- WoWInterface	http://www.wowinterface.com/downloads/info18901-KethoCombatLog.html

--- I don't have any previous programming experience or background in any (scripting) language
--- Note: This is my first AddOn

--- To Do: v0.96+
-- DevTools style debugging, and similar way to easily announce a chatlog entry
-- [maybe] check against spellID to see from what class it is, if unknown. would be a huge array though

KethoCombatLog = LibStub("AceAddon-3.0"):NewAddon("KethoCombatLog", "AceEvent-3.0", "AceTimer-3.0", "AceConsole-3.0", "LibSink-2.0")
local KCL = KethoCombatLog
local ACR = LibStub("AceConfigRegistry-3.0")
local ACD = LibStub("AceConfigDialog-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("KethoCombatLogLocale", true)

	--------------------
	--- 01  UPVALUES ---
	--------------------

local _G = _G
--# Lua APIs
local pairs, type = pairs, type
local tonumber = tonumber
local unpack, select = unpack, select
local time = time
local format = format
local strsub = strsub
local strlower = strlower
local band = bit.band -- BitLib library

--# WoW APIs
local UnitName, UnitClass = UnitName, UnitClass
local UnitInParty, UnitInRaid = UnitInParty, UnitInRaid
local UnitGroupRolesAssigned = UnitGroupRolesAssigned

--# Global Strings / Format Strings / Bitmasks
local TEXT_MODE_A_STRING_SOURCE_UNIT = TEXT_MODE_A_STRING_SOURCE_UNIT
local TEXT_MODE_A_STRING_DEST_UNIT = TEXT_MODE_A_STRING_DEST_UNIT
local TEXT_MODE_A_STRING_SOURCE_ICON = TEXT_MODE_A_STRING_SOURCE_ICON

local TEXT_MODE_A_STRING_RESULT_OVERKILLING = TEXT_MODE_A_STRING_RESULT_OVERKILLING
local TEXT_MODE_A_STRING_RESULT_CRITICAL = TEXT_MODE_A_STRING_RESULT_CRITICAL
local TEXT_MODE_A_STRING_RESULT_GLANCING = TEXT_MODE_A_STRING_RESULT_GLANCING
local TEXT_MODE_A_STRING_RESULT_CRUSHING = TEXT_MODE_A_STRING_RESULT_CRUSHING

local COMBATLOG_OBJECT_REACTION_FRIENDLY = COMBATLOG_OBJECT_REACTION_FRIENDLY
local COMBATLOG_OBJECT_REACTION_HOSTILE = COMBATLOG_OBJECT_REACTION_HOSTILE

local COMBATLOG_OBJECT_RAIDTARGET_MASK = COMBATLOG_OBJECT_RAIDTARGET_MASK
local COMBATLOG_OBJECT_RAIDTARGET1 = COMBATLOG_OBJECT_RAIDTARGET1
local COMBATLOG_OBJECT_RAIDTARGET2 = COMBATLOG_OBJECT_RAIDTARGET2
local COMBATLOG_OBJECT_RAIDTARGET3 = COMBATLOG_OBJECT_RAIDTARGET3
local COMBATLOG_OBJECT_RAIDTARGET4 = COMBATLOG_OBJECT_RAIDTARGET4
local COMBATLOG_OBJECT_RAIDTARGET5 = COMBATLOG_OBJECT_RAIDTARGET5
local COMBATLOG_OBJECT_RAIDTARGET6 = COMBATLOG_OBJECT_RAIDTARGET6
local COMBATLOG_OBJECT_RAIDTARGET7 = COMBATLOG_OBJECT_RAIDTARGET7
local COMBATLOG_OBJECT_RAIDTARGET8 = COMBATLOG_OBJECT_RAIDTARGET8

local STRING_SCHOOL_PHYSICAL = STRING_SCHOOL_PHYSICAL
local STRING_SCHOOL_HOLY = STRING_SCHOOL_HOLY
local STRING_SCHOOL_FIRE = STRING_SCHOOL_FIRE
local STRING_SCHOOL_NATURE = STRING_SCHOOL_NATURE
local STRING_SCHOOL_FROST = STRING_SCHOOL_FROST
local STRING_SCHOOL_SHADOW = STRING_SCHOOL_SHADOW
local STRING_SCHOOL_ARCANE = STRING_SCHOOL_ARCANE
local STRING_SCHOOL_HOLYSTRIKE = STRING_SCHOOL_HOLYSTRIKE
local STRING_SCHOOL_FLAMESTRIKE = STRING_SCHOOL_FLAMESTRIKE
local STRING_SCHOOL_HOLYFIRE = STRING_SCHOOL_HOLYFIRE
local STRING_SCHOOL_STORMSTRIKE = STRING_SCHOOL_STORMSTRIKE
local STRING_SCHOOL_HOLYSTORM = STRING_SCHOOL_HOLYSTORM
local STRING_SCHOOL_FIRESTORM = STRING_SCHOOL_FIRESTORM
local STRING_SCHOOL_FROSTSTRIKE = STRING_SCHOOL_FROSTSTRIKE
local STRING_SCHOOL_HOLYFROST = STRING_SCHOOL_HOLYFROST
local STRING_SCHOOL_FROSTFIRE = STRING_SCHOOL_FROSTFIRE
local STRING_SCHOOL_FROSTSTORM = STRING_SCHOOL_FROSTSTORM
local STRING_SCHOOL_SHADOWSTRIKE = STRING_SCHOOL_SHADOWSTRIKE
local STRING_SCHOOL_SHADOWLIGHT = STRING_SCHOOL_SHADOWLIGHT -- Twilight
local STRING_SCHOOL_SHADOWFLAME = STRING_SCHOOL_SHADOWFLAME
local STRING_SCHOOL_SHADOWSTORM = STRING_SCHOOL_SHADOWSTORM -- Plague
local STRING_SCHOOL_SHADOWFROST = STRING_SCHOOL_SHADOWFROST
local STRING_SCHOOL_SPELLSTRIKE = STRING_SCHOOL_SPELLSTRIKE
local STRING_SCHOOL_DIVINE = STRING_SCHOOL_DIVINE
local STRING_SCHOOL_SPELLFIRE = STRING_SCHOOL_SPELLFIRE	
local STRING_SCHOOL_SPELLSTORM = STRING_SCHOOL_SPELLSTORM
local STRING_SCHOOL_SPELLFROST = STRING_SCHOOL_SPELLFROST
local STRING_SCHOOL_SPELLSHADOW = STRING_SCHOOL_SPELLSHADOW
local STRING_SCHOOL_ELEMENTAL = STRING_SCHOOL_ELEMENTAL
local STRING_SCHOOL_CHROMATIC = STRING_SCHOOL_CHROMATIC
local STRING_SCHOOL_MAGIC = STRING_SCHOOL_MAGIC
local STRING_SCHOOL_CHAOS = STRING_SCHOOL_CHAOS
local STRING_SCHOOL_UNKNOWN = STRING_SCHOOL_UNKNOWN

-- table reference shortcuts
local profile, char
local color

local filterSelf, filterEverythingElse, filterPlayers, filterMonsters
local chatWindow, chatChannel
local Timestamp, overkillFormat, criticalFormat, glancingFormat, crushingFormat

-- modified globalstrings
local ADVANCED = gsub(ADVANCED_LABEL, "|T.-|t", "")
local OVERKILLING = gsub(TEXT_MODE_A_STRING_RESULT_OVERKILLING, "[%%d ()]", "")
local CRITICAL = gsub(TEXT_MODE_A_STRING_RESULT_CRITICAL, "[()]", "")
local GLANCING = gsub(TEXT_MODE_A_STRING_RESULT_GLANCING, "[()]", "")
local CRUSHING = gsub(TEXT_MODE_A_STRING_RESULT_CRUSHING, "[()]", "")

-- other
local ChatFrame
local optionsFrame
local cropped = "64:64:4:60:4:60"

-- class color arrays
SpellSchoolColor = {}
--local SpellSchoolColor
local ClassColor
local UnitColor

-- internal cooldowns array
local cd = {}

InterruptCheck = {}
local textLocal2, textChat2

local player = {
	name = UnitName("player"),
	class = select(2, UnitClass("player")),
}

local Taunt = {
-- Death Knight
	[56222] = true, -- Dark Command
	[49560] = true, -- Death Grip
	[51399] = true, -- Death Grip (melee range)
-- Druid
	[6795] = true, -- Growl
-- Hunter
	[20736] = true, -- Distracting Shot
-- Paladin
	[62124] = true, -- Hand of Reckoning
	[31790] = true, -- Righteous Defense
-- Warlock	
	[17735] = true, -- Suffering [Voidwalker]
-- Warrior
	[355] = true, -- Taunt
}

local Interrupt = {
	[47528] = true, -- Mind Freeze [Death Knight]
	[80964] = true, -- Skull Bash (Bear) [Druid]
	[80965] = true, -- Skull Bash (Cat) [Druid]
	[34490] = true, -- Silencing Shot [Marksmanship Hunter] (Silence)
	[2139] = true, -- Counterspell [Mage]
	[96231] = true, -- Rebuke [Paladin]
	[15487] = true, -- Silence [Shadow Priest] (Silence)
	[1766] = true, -- Kick [Rogue]
	[57994] = true, -- Wind Shear [Shaman]
--	[30108] = true, -- Unstable Affliction [Warlock] (Silence;Dispel Effect)
	[19647] = true, -- Spell Lock [Warlock Felhunter] (Silence)
	[6552] = true, -- Pummel [Warrior]
}

local SimpleInterrupt = {
	[47528] = true, -- Mind Freeze [Death Knight]
	[80964] = true, -- Skull Bash (Bear) [Druid]
	[80965] = true, -- Skull Bash (Cat) [Druid]
	[2139] = true, -- Counterspell [Mage]
	[96231] = true, -- Rebuke [Paladin]
	[1766] = true, -- Kick [Rogue]
	[57994] = true, -- Wind Shear [Shaman]
	[6552] = true, -- Pummel [Warrior]
}

local CrowdControl = {
-- Druid
	[2637] = true, -- Hibernate
	[33786] = true, -- Cyclone
-- Hunter
	[3355] = true, -- Freezing Trap
	[1513] = true, -- Scare Beast
	[19386] = true, -- Wyvern Sting
-- Mage
	[118] = true, -- Polymorph
	[61305] = true, -- Polymorph - Black Cat
	[28272] = true, -- Polymorph - Pig
	[61721] = true, -- Polymorph - Rabbit
	[61780] = true, -- Polymorph - Turkey
	[28271] = true, -- Polymorph - Turtle
-- Paladin
	[10326] = true, -- Turn Evil
	[20066] = true, -- Repentance
-- Priest
	[9484] = true, -- Shackle Undead
-- Rogue
	[6770] = true, -- Sap
	[2094] = true, -- Blind
-- Shaman
	[51514] = true, -- Hex
	[76780] = true, -- Bind Elemental
-- Warlock
	[710] = true, -- Banish
	[5782] = true, -- Fear
	[6358] = true, -- Seduction [Succubus]
}

local SpellSchoolString = {
	[0x1] = STRING_SCHOOL_PHYSICAL,
	[0x2] = STRING_SCHOOL_HOLY,
	[0x4] = STRING_SCHOOL_FIRE,
	[0x8] = STRING_SCHOOL_NATURE,
	[0x10] = STRING_SCHOOL_FROST,
	[0x20] = STRING_SCHOOL_SHADOW,
	[0x40] = STRING_SCHOOL_ARCANE,
	[0x3] = STRING_SCHOOL_HOLYSTRIKE,
	[0x5] = STRING_SCHOOL_FLAMESTRIKE,
	[0x6] = STRING_SCHOOL_HOLYFIRE,
	[0x9] = STRING_SCHOOL_STORMSTRIKE,
	[0xA] = STRING_SCHOOL_HOLYSTORM,
	[0xC] = STRING_SCHOOL_FIRESTORM,
	[0x11] = STRING_SCHOOL_FROSTSTRIKE,
	[0x12] = STRING_SCHOOL_HOLYFROST,
	[0x14] = STRING_SCHOOL_FROSTFIRE,
	[0x18] = STRING_SCHOOL_FROSTSTORM,
	[0x21] = STRING_SCHOOL_SHADOWSTRIKE,
	[0x22] = STRING_SCHOOL_SHADOWLIGHT,
	[0x24] = STRING_SCHOOL_SHADOWFLAME,
	[0x28] = STRING_SCHOOL_SHADOWSTORM,
	[0x30] = STRING_SCHOOL_SHADOWFROST,
	[0x41] = STRING_SCHOOL_SPELLSTRIKE,
	[0x42] = STRING_SCHOOL_DIVINE,
	[0x44] = STRING_SCHOOL_SPELLFIRE,
	[0x48] = STRING_SCHOOL_SPELLSTORM,
	[0x50] = STRING_SCHOOL_SPELLFROST,
	[0x60] = STRING_SCHOOL_SPELLSHADOW,
	[0x1C] = STRING_SCHOOL_ELEMENTAL,
	[0x7C] = STRING_SCHOOL_CHROMATIC,
	[0x7E] = STRING_SCHOOL_MAGIC,
	[0x7F] = STRING_SCHOOL_CHAOS,
}

local extraSpellEvent = {
	["SPELL_INTERRUPT"] = true,
	["SPELL_DISPEL"] = true,
	["SPELL_DISPEL_FAILED"] = true,
	["SPELL_STOLEN"] = true,
	["SPELL_AURA_BROKEN_SPELL"] = true,
}

local missType = {
	["ABSORB"] = COMBAT_TEXT_ABSORB,
	["BLOCK"] = COMBAT_TEXT_BLOCK,
	["DEFLECT"] = COMBAT_TEXT_DEFLECT,
	["DODGE"] = COMBAT_TEXT_DODGE,
	["EVADE"] = COMBAT_TEXT_EVADE,
	["IMMUNE"] = COMBAT_TEXT_IMMUNE,
	["MISS"] = COMBAT_TEXT_MISS,
	["PARRY"] = COMBAT_TEXT_PARRY,
	["REFLECT"] = COMBAT_TEXT_REFLECT,
	["RESIST"] = COMBAT_TEXT_RESIST,
}

	------------------------------
	--- 02  Options & Defaults ---
	------------------------------

local defaults = {
	profile = { -- KethoCombatLog.db.defaults.profile
		enableAddOn = true,
		Taunt = true,
		Death = true,
		PvE = true,
		chatWindow = 2, -- ChatFrame1
		chatChannel = 1, -- Disabled
		color = {
			Taunt = {1, 0, 0}, -- #FF0000 (Red)
			Interrupt = {0, 110/255, 1}, -- #006EFF
			Dispel = {1, 1, 1},
			Reflect = {1, 1, 1},
			CrowdControl = {1, 1, 1},
			CC_Break = {1, 1, 1},
			Death = {1, 1, 1},
			Resurrection = {175/255, 1, 47/255}, -- #ADFF2F (GreenYellow)
			-- Constants.lua: SCHOOL_MASK_PHYSICAL, ...
			Physical = {1.00, 1.00, 0.00}, -- #FFFF00
			Holy = {1.00, 0.90, 0.50}, -- #FFE680
			Fire = {1.00, 0.50, 0.00}, -- #FF8000
			Nature = {0.30, 1.00, 0.30}, -- #4DFF4D
			Frost = {0.50, 1.00, 1.00}, -- #80FFFF
			Shadow = {0.50, 0.50, 1.00}, -- #8080FF
			Arcane = {1.00, 0.50, 1.00}, -- #FF80FF
			-- RAID_CLASS_COLORS
			DeathKnight = {0.77, 0.12, 0.23}, -- #C41F3B
			Druid = {1.00 , 0.49, 0.04}, -- #FF7D0A
			Hunter = {0.67, 0.83, 0.45}, -- #ABD473
			Mage = {0.41, 0.80, 0.94}, -- #69CCF0
			Paladin = {0.96, 0.55, 0.73}, -- #F58CBA
			Priest = {1.00, 1.00, 1.00}, -- #FFFFFF
			Rogue = {1.00, 0.96, 0.41}, -- #FFF569
			Shaman = {0.00, 0.44, 0.87}, -- #0070DE
			Warlock = {0.58, 0.51, 0.79}, -- #9482C9
			Warrior = {0.78, 0.61, 0.43}, -- #C79C6E
			-- /dump COMBATLOG_DEFAULT_COLORS.unitColoring[32542]
			Friendly = {0.34, 0.64, 1.00}, -- #57A3FF
			Hostile = {0.75, 0.05, 0.05}, -- #BF0D0D
			Unknown = {191/255, 191/255, 191/255}, -- #BFBFBF
		},
		iconSize = 16,
		iconCropped = true,
		criticalFormat = true,
		filterSelf = true,
		filterEverythingElse = true,
		filterPlayers = true,
		BlizzardCombatLog = true,
		MissTaunt = true,
		MissInterrupt = true,
		MissCC = true,
		DeathPrevent = true,
	},
}

local options = {
	type = "group",
	name = "",
	args = {
		Main = {
			type = "group",
			name = "\124cffADFF2FKetho\124r |cffFFFFFFCombatLog|r |cffB6CA00v0.95|r |cff4169E1Beta|r",
			handler = KCL,
			args = {
				spacing = {type = "description", order = 1, name = ""},
				toggleTaunt = {
					type = "toggle",
					order = 2,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Nature_Reincarnation:20:20:1:0:"..cropped.."|t  |cff"..KCL:Dec2Hex(unpack(color.Taunt))..GetSpellInfo(355).."|r" end,
					get = function(i) return profile.Taunt end,
					set = function(i, v) profile.Taunt = v end,
				},
				toggleCrowdControl = {
					type = "toggle",
					order = 3,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Nature_Polymorph:20:20:1:0:"..cropped.."|t  |cff"..KCL:Dec2Hex(unpack(color.CrowdControl)).."Crowd Control|r" end,
					get = function(i) return profile.CrowdControl end,
					set = function(i, v) profile.CrowdControl = v end,
				},
			--	force newline for Blizzard/AceConfigDialog "wide" Options Window; http://forums.wowace.com/showthread.php?p=312303
				newline01 = {type = "description", order = 4, name = ""},
				toggleInterrupt = {
					type = "toggle",
					order = 5,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Kick:20:20:1:0:"..cropped.."|t  |cff"..KCL:Dec2Hex(unpack(color.Interrupt))..INTERRUPT.."|r" end,
					get = function(i) return profile.Interrupt end,
					set = function(i, v) profile.Interrupt = v end,
				},
				toggleCC_Break = {
					type = "toggle",
					order = 6,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Seal:20:20:1:0:"..cropped.."|t  |cff"..KCL:Dec2Hex(unpack(color.CC_Break)).."CC Breaker|r" end,
					get = function(i) return profile.CC_Break end,
					set = function(i, v) profile.CC_Break = v end,
				},
				newline02 = {type = "description", order = 7, name = ""},
				toggleDispel = {
					type = "toggle",
					order = 8,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Holy_DispelMagic:20:20:1:0:"..cropped.."|t  |cff"..KCL:Dec2Hex(unpack(color.Dispel))..GetSpellInfo(25808).."|r" end,
					get = function(i) return profile.Dispel end,
					set = function(i, v) profile.Dispel = v end,
				},
				toggleDeath = {
					type = "toggle",
					order = 9,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Rogue_FeignDeath:20:20:1:0:"..cropped.."|t  |cff"..KCL:Dec2Hex(unpack(color.Death))..TUTORIAL_TITLE25.."|r" end,
					get = function(i) return profile.Death end,
					set = function(i, v) profile.Death = v end,
				},
				newline03 = {type = "description", order = 10, name = ""},
				toggleReflect = {
					type = "toggle",
					order = 11,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Warrior_ShieldReflection:20:20:1:0:"..cropped.."|t  |cff"..KCL:Dec2Hex(unpack(color.Reflect))..REFLECT.."|r" end,
					get = function(i) return profile.Reflect end,
					set = function(i, v) profile.Reflect = v end,
				},
				toggleResurrection = {
					type = "toggle",
					order = 12,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Holy_Resurrection:20:20:1:0:"..cropped.."|t  |cff"..KCL:Dec2Hex(unpack(color.Resurrection))..GetSpellInfo(2006).."|r" end,
					get = function(i) return profile.Resurrection end,
					set = function(i, v) profile.Resurrection = v end,
				},
				header01 = {
					type = "header",
					order = 14,
					name = "",
				},
				togglePvE = {
					type = "toggle",
					order = 15,
					descStyle = "",
					width = "half",
					name = "  |cffA8A8FFPvE|r", -- /dump ChatTypeInfo.PARTY {r = 0.666, g = 0.666, b = 1.000}
					disabled = "OptionsDisabled",
					get = function(i) return profile.PvE end,
					set = function(i, v) profile.PvE = v end,
				},
				togglePvP = {
					type = "toggle",
					order = 16,
					width = "half",
					descStyle = "",
					name = "  |cffFF7F00"..PVP.."|r", -- /dump ChatTypeInfo.RAID {r = 1.000, g = 0.498, b = 0.000}
					disabled = "OptionsDisabled",
					get = function(i) return profile.PvP end,
					set = function(i, v) profile.PvP = v end,
				},
				toggleWorld = {
					type = "toggle",
					order = 17,
					descStyle = "",
					name = "  World",
					disabled = "OptionsDisabled",
					get = function(i) return profile.World end,
					set = function(i, v) profile.World = v end,
				},
				header02 = {
					type = "header",
					order = 18,
					name = "",
				},
				selectChatWindow = {
					type = "select",
					order = 19,
					descStyle = "",
					name = "   |cffFFFFFF"..CHAT.." Window|r",
					disabled = "OptionsDisabled",
					values = function()
						local ChatWindowList = {}
						ChatWindowList[1] = "|cffFF0000<"..ADDON_DISABLED..">|r"
						for i = 1, NUM_CHAT_WINDOWS do
							local a = GetChatWindowInfo(i)
							if a ~= "" then ChatWindowList[i+1] = "|cff2E9AFE"..i..".|r  "..select(1, GetChatWindowInfo(i)) end
						end
						return ChatWindowList end,
					get = function(i) return profile.chatWindow end,
					set = function(i, v)
						profile.chatWindow = v; chatWindow = profile.chatWindow
						if v > 1 then
							ChatFrame = _G["ChatFrame"..v-1]
							ChatFrame:AddMessage("|cffADFF2FKetho CombatLog|r: Chat Frame |cff57A3FF"..(v-1)..".|r |cffADFF2F"..GetChatWindowInfo(v-1).."|r")
						end
					end,
				},
				selectChatChannel = {
					type = "select",
					order = 20,
					descStyle = "",
					name = "   |cffFFFFFF"..CHAT.." "..CHANNEL.."|r",
					disabled = "OptionsDisabled",
					values = function() local ChatChannelList = {}
						ChatChannelList[1] = "|cffFF0000<"..ADDON_DISABLED..">|r"
						ChatChannelList[2] = "|cff2E9AFE#|r   "..CHAT_MSG_SAY
						ChatChannelList[3] = "|cff2E9AFE#|r   |cffFF4040"..CHAT_MSG_YELL.."|r"
						ChatChannelList[4] = "|cff2E9AFE#|r   |cffA8A8FF"..CHAT_MSG_PARTY.."|r / |cffFF7F00"..CHAT_MSG_RAID.."|r"
						for i = 1, 10 do
							local a = select((i*2)-1, GetChannelList()) -- this is was kinda hard to code, seeing how GetChannelList() works..
							if a then ChatChannelList[a+4] = "|cff2E9AFE"..a..".|r  "..select(i*2,GetChannelList()) end
						end
						return ChatChannelList end,
					get = function(i) return profile.chatChannel end,
					set = function(i, v) profile.chatChannel = v; chatChannel = profile.chatChannel end,
				},
				descEnable = {
					type = "description",
					order = 21,
					fontSize = "large",
					name = function() return KCL:OptionsDisabled() and " Type |cff2E9AFE/ket on|r to enable" or "" end,
				},
			},
		},
		Advanced = {
			type = "group",
			name = "",
			handler = KCL,
			args = {
				groupColoring = {
					type = "group",
					order = 1,
					name = "|TInterface\\Icons\\INV_Misc_Gem_Variety_02:14:14:1:0:"..cropped.."|t  |cffFFFFFF"..COLORS.."|r",
					args = {
						colorTaunt = {
							type = "color",
							order = 1,
							name = "|TInterface\\Icons\\Spell_Nature_Reincarnation:16:16:1:0:"..cropped.."|t  "..GetSpellInfo(355),
							get = function(i) return unpack(color.Taunt) end,
							set = function(info, r,g,b) color.Taunt = {r, g, b} end,
						},
						colorInterrupt = {
							type = "color",
							order = 2,
							name = "|TInterface\\Icons\\Ability_Kick:16:16:1:0:"..cropped.."|t  "..INTERRUPT,
							get = function(i) return unpack(color.Interrupt) end,
							set = function(info, r,g,b) color.Interrupt = {r, g, b} end,
						},
						colorDispel = {
							type = "color",
							order = 3,
							name = "|TInterface\\Icons\\Spell_Holy_DispelMagic:16:16:1:0:"..cropped.."|t  "..GetSpellInfo(25808),
							get = function(i) return unpack(color.Dispel) end,
							set = function(info, r,g,b) color.Dispel = {r, g, b} end,
						},
						colorReflect = {
							type = "color",
							order = 4,
							name = "|TInterface\\Icons\\Ability_Warrior_ShieldReflection:16:16:1:0:"..cropped.."|t  "..REFLECT,
							get = function(i) return unpack(color.Reflect) end,
							set = function(info, r,g,b) color.Reflect = {r, g, b} end,
						},
						colorCrowdControl = {
							type = "color",
							order = 5,
							name = "|TInterface\\Icons\\Spell_Nature_Polymorph:16:16:1:0:"..cropped.."|t  Crowd Control",
							get = function(i) return unpack(color.CrowdControl) end,
							set = function(info, r,g,b) color.CrowdControl = {r, g, b} end,
						},
						colorCC_Break = {
							type = "color",
							order = 6,
							name = "|TInterface\\Icons\\Ability_Seal:16:16:1:0:"..cropped.."|t  CC Breaker",
							get = function(i) return unpack(color.CC_Break) end,
							set = function(info, r,g,b) color.CC_Break = {r, g, b} end,
						},
						colorDeath = {
							type = "color",
							order = 7,
							name = "|TInterface\\Icons\\Ability_Rogue_FeignDeath:16:16:1:0:"..cropped.."|t  "..TUTORIAL_TITLE25,
							get = function(i) return unpack(color.Death) end,
							set = function(info, r,g,b) color.Death = {r, g, b} end,
						},
						colorResurrection = {
							type = "color",
							order = 8,
							name = "|TInterface\\Icons\\Spell_Holy_Resurrection:16:16:1:0:"..cropped.."|t  "..GetSpellInfo(2006),
							get = function(i) return unpack(color.Resurrection) end,
							set = function(info, r,g,b) color.Resurrection = {r, g, b} end,
						},
						spacing01 = {type = "description", order = 9, name = " "},
						colorDeathKnight = {
							type = "color",
							order = 10,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:16:16:1:0:256:256:68:124:133:189|t  Death Knight",
							get = function(i) return unpack(color.DeathKnight) end,
							set = function(info, r,g,b) color.DeathKnight = {r, g, b}; ClassColor["DEATHKNIGHT"] = KCL:Dec2Hex(r, g, b) end,
						},
						colorDruid = {
							type = "color",
							order = 11,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:16:16:1:0:256:256:194:250:4:60|t  Druid",
							get = function(i) return unpack(color.Druid) end,
							set = function(info, r,g,b) color.Druid = {r, g, b}; ClassColor["DRUID"] = KCL:Dec2Hex(r, g, b) end,
						},
						colorHunter = {
							type = "color",
							order = 12,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:16:16:1:0:256:256:4:60:68:124|t  Hunter",
							get = function(i) return unpack(color.Hunter) end,
							set = function(info, r,g,b) color.Hunter = {r, g, b}; ClassColor["HUNTER"] = KCL:Dec2Hex(r, g, b) end,
						},
						colorMage = {
							type = "color",
							order = 13,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:16:16:1:0:256:256:68:124:4:60|t  Mage",
							get = function(i) return unpack(color.Mage) end,
							set = function(info, r,g,b) color.Mage = {r, g, b}; ClassColor["MAGE"] = KCL:Dec2Hex(r, g, b) end,
						},
						colorPaladin = {
							type = "color",
							order = 14,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:16:16:1:0:256:256:4:60:132:188|t  Paladin",
							get = function(i) return unpack(color.Paladin) end,
							set = function(info, r,g,b) color.Paladin = {r, g, b}; ClassColor["PALADIN"] = KCL:Dec2Hex(r, g, b) end,
						},
						colorPriest = {
							type = "color",
							order = 15,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:16:16:1:0:256:256:130:186:68:124|t  Priest",
							get = function(i) return unpack(color.Priest) end,
							set = function(info, r,g,b) color.Priest = {r, g, b}; ClassColor["PRIEST"] = KCL:Dec2Hex(r, g, b) end,
						},
						colorRogue = {
							type = "color",
							order = 16,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:16:16:1:0:256:256:131:187:4:60|t  Rogue",
							get = function(i) return unpack(color.Rogue) end,
							set = function(info, r,g,b) color.Rogue = {r, g, b}; ClassColor["ROGUE"] = KCL:Dec2Hex(r, g, b) end,
						},
						colorShaman = {
							type = "color",
							order = 17,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:16:16:1:0:256:256:68:124:68:124|t  Shaman",
							get = function(i) return unpack(color.Shaman) end,
							set = function(info, r,g,b) color.Shaman = {r, g, b}; ClassColor["SHAMAN"] = KCL:Dec2Hex(r, g, b) end,
						},
						colorWarlock = {
							type = "color",
							order = 18,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:16:16:1:0:256:256:194:250:68:124|t  Warlock",
							get = function(i) return unpack(color.Warlock) end,
							set = function(info, r,g,b) color.Warlock = {r, g, b}; ClassColor["WARLOCK"] = KCL:Dec2Hex(r, g, b) end,
						},
						colorWarrior = {
							type = "color",
							order = 19,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:16:16:1:0:256:256:4:60:4:60|t  Warrior",
							get = function(i) return unpack(color.Warrior) end,
							set = function(info, r,g,b) color.Warrior = {r, g, b}; ClassColor["WARRIOR"] = KCL:Dec2Hex(r, g, b) end,
						},
						spacing03 = {type = "description", order = 20, name = " "},
						colorPhysical = {
							type = "color",
							order = 21,
							name = "|TInterface\\Icons\\Spell_Nature_Strength:16:16:1:0:"..cropped.."|t  "..STRING_SCHOOL_PHYSICAL,
							get = function(i) return unpack(color.Physical) end,
							set = function(info, r,g,b) color.Physical = {r, g, b}; SpellSchoolColor[0x1] = KCL:Dec2Hex(r, g, b) end,
						},
						colorHoly = {
							type = "color",
							order = 22,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon2:20:20:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_HOLY,
							get = function(i) return unpack(color.Holy) end,
							set = function(info, r,g,b) color.Holy = {r, g, b}; SpellSchoolColor[0x2] = KCL:Dec2Hex(r, g, b) end,
						},
						colorFire = {
							type = "color",
							order = 23,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon3:20:20:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_FIRE,
							get = function(i) return unpack(color.Fire) end,
							set = function(info, r,g,b) color.Fire = {r, g, b}; SpellSchoolColor[0x4] = KCL:Dec2Hex(r, g, b) end,
						},
						colorNature = {
							type = "color",
							order = 24,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon4:20:20:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_NATURE,
							get = function(i) return unpack(color.Nature) end,
							set = function(info, r,g,b) color.Nature = {r, g, b}; SpellSchoolColor[0x8] = KCL:Dec2Hex(r, g, b) end,
						},
						colorFrost = {
							type = "color",
							order = 25,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon5:20:20:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_FROST,
							get = function(i) return unpack(color.Frost) end,
							set = function(info, r,g,b) color.Frost = {r, g, b}; SpellSchoolColor[0x10] = KCL:Dec2Hex(r, g, b) end,
						},
						colorShadow = {
							type = "color",
							order = 26,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon6:20:20:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_SHADOW,
							get = function(i) return unpack(color.Shadow) end,
							set = function(info, r,g,b) color.Shadow = {r, g, b}; SpellSchoolColor[0x20] = KCL:Dec2Hex(r, g, b) end,
						},
						colorArcane = {
							type = "color",
							order = 27,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon7:20:20:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_ARCANE,
							get = function(i) return unpack(color.Arcane) end,
							set = function(info, r,g,b) color.Arcane = {r, g, b}; SpellSchoolColor[0x40] = KCL:Dec2Hex(r, g, b) end,
						},
						spacing02 = {type = "description", order = 28, name = " "},
						colorFriendly = {
							type = "color",
							order = 29,
							name = "|TInterface\\Icons\\Spell_ChargePositive:16:16:1:0:"..cropped.."|t  "..FRIENDLY,
							get = function(i) return unpack(color.Friendly) end,
							set = function(info, r,g,b) color.Friendly = {r, g, b}; UnitColor[1] = KCL:Dec2Hex(r, g, b) end,
						},
						colorHostile = {
							type = "color",
							order = 30,
							name = "|TInterface\\Icons\\Spell_ChargeNegative:16:16:1:0:"..cropped.."|t  "..HOSTILE,
							get = function(i) return unpack(color.Hostile) end,
							set = function(info, r,g,b) color.Hostile = {r, g, b}; UnitColor[2] = KCL:Dec2Hex(r, g, b) end,
						},
						colorUnknown = {
							type = "color",
							order = 31,
							name = "|TInterface\\Icons\\INV_Misc_QuestionMark:16:16:1:0:"..cropped.."|t  "..UNKNOWN,
							get = function(i) return unpack(color.Unknown) end,
							set = function(info, r,g,b) color.Unknown = {r, g, b}; UnitColor[3] = KCL:Dec2Hex(r, g, b) end,
						},
						spacing04 = {type = "description", order = 32, name = "\n"},
						executeReset = {
							type = "execute",
							order = 33,
							descStyle = "",
							name = "|cffFFFFFFReset Colors|r",
							confirm = true, confirmText = "Reset Colors?",
							-- for some reason the colors that are "called/copied" from also get changed,
							-- so the reset function only works once?!
						--	func = function() profile.color = defaults.profile.color; KCL:RefreshTableRefs() end,
							func = function()
								profile.color = {
									Taunt = {1, 0, 0},
									Interrupt = {0, 110/255, 1},
									Dispel = {1, 1, 1},
									Reflect = {1, 1, 1},
									CrowdControl = {1, 1, 1},
									CC_Break = {1, 1, 1},
									Death = {1, 1, 1},
									Resurrection = {175/255, 1, 47/255},
									Physical = {1.00, 1.00, 0.00},
									Holy = {1.00, 0.90, 0.50},
									Fire = {1.00, 0.50, 0.00},
									Nature = {0.30, 1.00, 0.30},
									Frost = {0.50, 1.00, 1.00},
									Shadow = {0.50, 0.50, 1.00},
									Arcane = {1.00, 0.50, 1.00},
									DeathKnight = {0.77, 0.12, 0.23},
									Druid = {1.00 , 0.49, 0.04},
									Hunter = {0.67, 0.83, 0.45},
									Mage = {0.41, 0.80, 0.94},
									Paladin = {0.96, 0.55, 0.73},
									Priest = {1.00, 1.00, 1.00},
									Rogue = {1.00, 0.96, 0.41},
									Shaman = {0.00, 0.44, 0.87},
									Warlock = {0.58, 0.51, 0.79},
									Warrior = {0.78, 0.61, 0.43},
									Friendly = {0.34, 0.64, 1.00},
									Hostile = {0.75, 0.05, 0.05},
									Unknown = {191/255, 191/255, 191/255},
								}
								KCL:RefreshTableRefs()
							end,
						},
					},
				},
				groupIcon = {
					type = "group",
					order = 2,
					name = "|TINTERFACE\\ICONS\\inv_misc_orb_05:14:14:1:0:"..cropped.."|t  |cffFFFFFFIcons|r",
					args = {
						selectIconSize = {
							type = "select",
							order = 1,
							descStyle = "", 
							name = "|cffFFFFFF"..EMBLEM_SYMBOL.." Size|r",
							values = {"|cffFF0000<"..ADDON_DISABLED..">|r", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, " 12", nil, " 14", nil, " 16  |cffFBDB00(Default)|r", nil, " 18",  nil, " 20", nil, " 22", nil, " 24", nil, " 26", nil, " 28", nil, " 30", nil, " 32"},
							get = function(i) return profile.iconSize end,
							set = function(i, v) profile.iconSize = v; iconSize = profile.iconSize end,
						},
						newlin = {type = "description", order = 2, name = " "},
						toggleCropIcon = {
							type = "toggle",
							order = 3,
							descStyle = "",
							name = "|TInterface\\Icons\\inv_misc_orb_05:20:20:1:0|t |TInterface\\Icons\\inv_misc_orb_05:20:20:1:0:64:64:4:60:4:60|t  Crop",
							disabled = function() return not profile.iconSize end,
							get = function(i) return profile.iconCropped end,
							set = function(i, v)
								profile.iconCropped = v
								cropped = v and "64:64:4:60:4:60" or ""
							end,
						},
					}
				},
				groupOther = {
					type = "group",
					order = 3,
					name = "|TInterface\\Icons\\Trade_Engineering:14:14:1:0:"..cropped.."|t  |cffFFFFFF"..OTHER.."|r",
					args = {
						header1 = {type = "header", order = 1, name = "Message Format"},
						toggleTimestamp = {
							type = "toggle",
							order = 2,
							desc = TIMESTAMP_COMBATLOG_TOOLTIP,
							name = TIMESTAMPS_LABEL,
							get = function(i) return profile.Timestamp end,
							set = function(i, v) profile.Timestamp = v; Timestamp = profile.Timestamp end,
						},
						toggleOverkillFormat = {
							type = "toggle",
							order = 3,
							desc = "<message> |cff71D5FF"..TEXT_MODE_A_STRING_RESULT_OVERKILLING.."|r",
							name = OVERKILLING,
							get = function(i) return profile.overkillFormat end,
							set = function(i, v) profile.overkillFormat = v; overkillFormat = profile.overkillFormat end,
						},
						toggleCriticalFormat = {
							type = "toggle",
							order = 4,
							desc = "<message> |cff71D5FF"..TEXT_MODE_A_STRING_RESULT_CRITICAL.."|r",
							name = CRITICAL,
							get = function(i) return profile.criticalFormat end,
							set = function(i, v) profile.criticalFormat = v; criticalFormat = profile.criticalFormat end,
						},
						toggleGlancingFormat = {
							type = "toggle",
							order = 5,
							desc = "<message> |cff71D5FF"..TEXT_MODE_A_STRING_RESULT_GLANCING .."|r",
							name = GLANCING,
							get = function(i) return profile.glancingFormat end,
							set = function(i, v) profile.glancingFormat = v; glancingFormat = profile.glancingFormat end,
						},
						toggleCrushingFormat = {
							type = "toggle",
							order = 6,
							desc = "<message> |cff71D5FF"..TEXT_MODE_A_STRING_RESULT_CRUSHING.."|r",
							name = CRUSHING,
							get = function(i) return profile.crushingFormat end,
							set = function(i, v) profile.crushingFormat = v; crushingFormat = profile.crushingFormat end,
						},
						header3 = {type = "header", order = 7, name = OTHER},
						toggleBlizzardCombatLog = {
							type = "toggle",
							order = 8,
							desc = BINDING_NAME_TOGGLECOMBATLOG,
							name = "Blizzard CombatLog",
							get = function(i) return profile.BlizzardCombatLog end,
							set = function(i, v) profile.BlizzardCombatLog = v
								if v then
									COMBATLOG:RegisterEvent("COMBAT_LOG_EVENT")
									print("Blizzard CombatLog: |cffB6CA00Enabled|r")
								else
									COMBATLOG:UnregisterEvent("COMBAT_LOG_EVENT")
									print("Blizzard CombatLog: |cffFF2424Disabled|r")
								end
							end,
						},
						toggleLoggingChat = {
							type = "toggle",
							order = 9,
							desc = "Note: |cff71D5FFPrat|r can override these settings",
							name = CHAT.." Logging",
							get = function() return LoggingChat() end,
							set = SlashCmdList["CHATLOG"],
						},
						toggleLoggingCombat = {
							type = "toggle",
							order = 10,
							descStyle = "",
							name = COMBAT.." Logging",
							get = function() return LoggingCombat() end,
							set = SlashCmdList["COMBATLOG"],
						},
					},
				},
				groupSpacing1 = {
					type = "group",
					order = 4,
					name = "",
					disabled = true,
					args = {},
				},
				groupFilter = {
					type = "group",
					order = 5,
					name = "|TInterface\\Icons\\Spell_Holy_Silence:14:14:1:0:"..cropped.."|t  |cffFFFFFF"..FILTERS.."|r",
					args = {
						header1 = {type = "header", order = 1, name = COMBAT_LOG_MENU_BOTH},
						toggleSelf = {
							type = "toggle",
							order = 2,
							descStyle = "",
							name = YOU,
							get = function(i) return profile.filterSelf end,
							set = function(i, v) profile.filterSelf = v
								filterSelf = profile.filterSelf
								if not v then
									filterEverythingElse, profile.filterEverythingElse = true, true
								end
							end,
						},
						toggleEverythingElse = {
							type = "toggle",
							order = 3,
							descStyle = "",
							name = "Others",
							get = function(i) return profile.filterEverythingElse end,
							set = function(i, v) profile.filterEverythingElse = v 
								filterEverythingElse = profile.filterEverythingElse
								if not v then
									filterSelf, profile.filterSelf = true, true
								end
							end,
						},
						header2 = {type = "header", order = 4, name = BY_SOURCE.." "..TYPE},
						togglePlayers = {
							type = "toggle",
							order = 5,
							descStyle = "",
							name = TUTORIAL_TITLE19,
							get = function(i) return profile.filterPlayers end,
							set = function(i, v) profile.filterPlayers = v
								filterPlayers = profile.filterPlayers
								if not v then
									filterMonsters, profile.filterMonsters = true, true
								end
							end,
						},
						toggleMonsters = {
							type = "toggle",
							order = 6,
							descStyle = "",
							name = "NPCs",
							get = function(i) return profile.filterMonsters end,
							set = function(i, v) profile.filterMonsters = v 
								filterMonsters = profile.filterMonsters
								if not v then
									filterPlayers, profile.filterPlayers = true, true
								end
							end,
						},
						header3 = {type = "header", order = 7, name = TANK},
						toggleTankTaunt = {
							type = "toggle",
							order = 8,
							descStyle = "",
							name = function() return "|TInterface\\LFGFRAME\\UI-LFG-ICON-ROLES:20:20:-3:0:256:256:1:65:68:132|t|TInterface\\Icons\\Spell_Nature_Reincarnation:16:16:0:0:"..cropped.."|t |cff6FAFE6"..TANK.."|r Taunt" end,
							disabled = function() return not profile.Taunt or not profile.enableAddOn end,
							get = function(i) return profile.TankTaunt end,
							set = function(i, v) profile.TankTaunt = v end,
						},
						toggleTankBreak = {
							type = "toggle",
							order = 9,
							descStyle = "",
							name = function() return "|TInterface\\LFGFRAME\\UI-LFG-ICON-ROLES:20:20:-3:0:256:256:1:65:68:132|t|TInterface\\Icons\\Ability_Seal:16:16:0:0:"..cropped.."|t |cff6FAFE6"..TANK.."|r CC Break" end,
							disabled = function() return not profile.CC_Break or not profile.enableAddOn end,
							get = function(i) return profile.TankBreak end,
							set = function(i, v) profile.TankBreak = v end,
						},
						togglePetGrowl = {
							type = "toggle",
							order = 10,
							descStyle = "",
							name = function() return " |TInterface\\Icons\\INV_Weapon_Bow_07:16:16:-4:0:"..cropped.."|t|TInterface\\Icons\\Ability_Physical_Taunt:16:16:1:0:"..cropped.."|t  |cffABD473"..PET.."|r "..GetSpellInfo(2649) end,
							disabled = function() return not profile.Taunt or not profile.enableAddOn end,
							get = function(i) return profile.PetGrowl end,
							set = function(i, v) profile.PetGrowl = v end,
						},
					},
				},
				groupEvent = {
					type = "group",
					order = 6,
					name = "|TInterface\\Icons\\Ability_Marksmanship:14:14:1:0:"..cropped.."|t  |cffFFFFFFExtra Events|r",
					args = {
						header1 = {type = "header", order = 1, name = "|TInterface\\Icons\\Ability_Marksmanship:14:14:1:0:"..cropped.."|t "..MISSES},
						toggleMissTaunt = {
							type = "toggle",
							order = 2,
							descStyle = "",
							name = function() return "|TInterface\\Icons\\Spell_Nature_Reincarnation:16:16:1:0:"..cropped.."|t  "..GetSpellInfo(355) end,
							disabled = function() return not profile.Taunt or profile.MissAll end,
							get = function(i) return profile.MissTaunt end,
							set = function(i, v) profile.MissTaunt = v end,
						},
						toggleMissInterrupt = {
							type = "toggle",
							order = 3,
							descStyle = "",
							name = function() return "|TInterface\\Icons\\Ability_Kick:16:16:1:0:"..cropped.."|t  "..INTERRUPT end,
							disabled = function() return not profile.Interrupt or profile.MissAll end,
							get = function(i) return profile.MissInterrupt end,
							set = function(i, v) profile.MissInterrupt = v end,
						},
						toggleMissCC = {
							type = "toggle",
							order = 4,
							descStyle = "",
							name = function() return "|TInterface\\Icons\\Spell_Nature_Polymorph:16:16:1:0:"..cropped.."|t  Crowd Control" end,
							disabled = function() return not profile.CrowdControl or profile.MissAll end,
							get = function(i) return profile.MissCC end,
							set = function(i, v) profile.MissCC = v end,
						},
						toggleMissAll = {
							type = "toggle",
							order = 5,
							descStyle = "",
							name = function() return "|TInterface\\Icons\\Spell_ChargePositive:16:16:1:0:"..cropped.."|t  |cff71D5FF"..ALL.."|r" end,
							disabled = "OptionsDisabled",
							get = function(i) return profile.MissAll end,
							set = function(i, v) profile.MissAll = v end,
						},						
						header3 = {type = "header", order = 6, name = OTHER},
						toggleDeathPrevent = {
							type = "toggle",
							order = 7,
							descStyle = "",
							name = function() return "|TInterface\\Icons\\Spell_Holy_GuardianSpirit:16:16:1:0:"..cropped.."|t  |cff"..KCL:Dec2Hex(unpack(color.Death))..TUTORIAL_TITLE25.."|r Prevent" end,
							disabled = function() return not profile.Death end,
							get = function(i) return profile.DeathPrevent end,
							set = function(i, v) profile.DeathPrevent = v end,
						},
						toggleWastedInterrupt = {
							type = "toggle",
							order = 8,
							descStyle = "",
							name = function() return "|TInterface\\Icons\\Ability_Kick:16:16:1:0:"..cropped.."|t  \"Wasted\" "..INTERRUPT end,
							disabled = function() return not profile.Interrupt end,
							get = function(i) return profile.WastedInterrupt end,
							set = function(i, v) profile.WastedInterrupt = v end,
						},
					},
				},
				groupSpacing = {
					type = "group",
					order = 7,
					name = "",
					disabled = true,
					args = {}
				},
				groupAbility = {
					type = "group",
					order = 8,
					disabled = true,
					name = "|TInterface\\Icons\\Ability_Rogue_TricksOftheTrade:14:14:1:0:"..cropped.."|t  "..COMBATLOG_HIGHLIGHT_ABILITY.."  |cffFF0000(NYI)|r",
					args = {
						toggleSoulstoneResurrection = {
							type = "toggle",
							order = 1,
							desc = "", 
							name = "|TInterface\\Icons\\Spell_Shadow_SoulGem:16:16:1:0:"..cropped.."|t  |cff9482C9"..GetSpellInfo(20707).."|r",
							get = function(i) return profile.abilitySoulstone end,
							set = function(i, v) profile.abilitySoulstone = v end,
						},
						toggleFocusMagic = {
							type = "toggle",
							order = 2,
							desc = "", 
							name = "|TInterface\\Icons\\Spell_Arcane_StudentOfMagic:16:16:1:0:"..cropped.."|t  |cff69CCF0"..GetSpellInfo(54646).."|r",
							get = function(i) return profile.abilityFocusMagic end,
							set = function(i, v) profile.abilityFocusMagic = v end,
						},
						toggleVigilance = {
							type = "toggle",
							order = 3,
							desc = "", 
							name = "|TInterface\\Icons\\Ability_Warrior_Vigilance:16:16:1:0:"..cropped.."|t  |cffC79C6E"..GetSpellInfo(50720).."|r",
							get = function(i) return profile.abilityVigilance end,
							set = function(i, v) profile.abilityVigilance = v end,
						},
						toggleMisdirection = {
							type = "toggle",
							order = 4,
							desc = "", 
							name = "|TInterface\\Icons\\Ability_Hunter_Misdirection:16:16:1:0:"..cropped.."|t  |cffABD473"..GetSpellInfo(34477).."|r",
							get = function(i) return profile.abilityMisdirection end,
							set = function(i, v) profile.abilityMisdirection = v end,
						},
						toggleTricksTrade = {
							type = "toggle",
							order = 5,
							desc = "", 
							name = "|TInterface\\Icons\\Ability_Rogue_TricksOftheTrade:16:16:1:0:"..cropped.."|t  |cffFFF569"..GetSpellInfo(57934).."|r",
							get = function(i) return profile.abilityTricksTrade end,
							set = function(i, v) profile.abilityTricksTrade = v end,
						},
						toggleInnervate = {
							type = "toggle",
							order = 6,
							desc = "", 
							name = "|TInterface\\Icons\\Spell_Nature_Lightning:16:16:1:0:"..cropped.."|t  |cffFF7D0A"..GetSpellInfo(29166).."|r",
							get = function(i) return profile.abilityInnervate end,
							set = function(i, v) profile.abilityInnervate = v end,
						},
						toggleHeroismBloodlust = {
							type = "toggle",
							order = 7,
							desc = "", 
							name = "|TInterface\\Icons\\Ability_Shaman_Heroism:16:16:1:0:"..cropped.."|t |TInterface\\Icons\\Spell_Nature_BloodLust:16:16:1:0:"..cropped.."|t  |cff0070DE"..GetSpellInfo(32182).."|r / |cff0070DE"..GetSpellInfo(2825).."|r",
							get = function(i) return profile.abilityBloodlust end,
							set = function(i, v) profile.abilityBloodlust = v end,
						},
						toggleRitualRefreshment = {
							type = "toggle",
							order = 8,
							desc = "", 
							name = "|TInterface\\Icons\\Spell_Arcane_MassDispel:16:16:1:0:"..cropped.."|t  |cff69CCF0"..GetSpellInfo(43987).."|r",
							get = function(i) return profile.abilityRitualRefreshment end,
							set = function(i, v) profile.abilityRitualRefreshment = v end,
						},
						toggleFearWard = {
							type = "toggle",
							order = 9,
							desc = "", 
							name = "|TInterface\\Icons\\Spell_Holy_Excorcism:16:16:1:0:"..cropped.."|t  "..GetSpellInfo(6346).."",
							get = function(i) return profile.abilityFearWard end,
							set = function(i, v) profile.abilityFearWard = v end,
						},
						toggleMindVision = {
							type = "toggle",
							order = 10,
							desc = "", 
							name = "|TInterface\\Icons\\Spell_Holy_MindVision:16:16:1:0:"..cropped.."|t  "..GetSpellInfo(2096).."",
							get = function(i) return profile.abilityMindVision end,
							set = function(i, v) profile.abilityMindVision = v end,
						},
					},
				},
				groupFun = {
					type = "group",
					order = 9,
					disabled = true,
					name = "|TInterface\\AddOns\\Ketho_CombatLog\\Images\\Awesome:14:14:1:0|t  Fun  |cffFF0000(NYI)|r",
					args = {
						toggleFeast = {
							type = "toggle",
							order = 1,
							desc = "|cffF6ADC6\"om nom nom nom\"|r", 
							name = "  Feasts",
							get = function(i) return profile.Feast end,
							set = function(i, v) profile.Feast = v end,
						},
						descriptionFeasts = {
							type = "description",
							order = 2,
							name = "   |TInterface\\Icons\\Spell_Misc_Food:16:16:0:0:"..cropped.."|t |TInterface\\Icons\\INV_Misc_Food_Meat_Cooked_02:16:16:0:0:"..cropped.."|t |TInterface\\Icons\\INV_Misc_Food_99:16:16:0:0:"..cropped.."|t |TInterface\\Icons\\INV_Misc_Fish_52:16:16:0:0:"..cropped.."|t |TInterface\\Icons\\Ability_Hunter_Pet_Boar:16:16:0:0:"..cropped.."|t",
						},
						header2 = {type = "header", order = 3, name = ""},
						toggleRepairBot = {
							type = "toggle",
							order = 4,
							desc = "", 
							name = "  Repair Bots",
							get = function(i) return profile.RepairBot end,
							set = function(i, v) profile.RepairBot = v end,
						},
						descriptionRepairBot = {
							type = "description",
							order = 5,
							name = "   |TInterface\\Minimap\\Tracking\\Repair:16:16:-2:0:"..cropped.."|t |TInterface\\Icons\\inv_pet_lilsmoky:16:16:0:0:"..cropped.."|t |TInterface\\Icons\\INV_Misc_EngGizmos_14:16:16:0:0:"..cropped.."|t |TInterface\\Icons\\inv_misc_molle:16:16:0:0:"..cropped.."|t",
						},
						header3 = {type = "header", order = 6, name = ""},
						toggleFun = {
							type = "toggle",
							order = 7,
							desc = "|cffF6ADC6\"trolololol\"|r", 
							name = "  Fun",
							get = function(i) return profile.Fun end,
							set = function(i, v) profile.Fun = v end,
						},
						descriptionFun = {
							type = "description",
							order = 8,
							name = "   |TInterface\\Icons\\inv_misc_mohawkgrenade:16:16:0:0:"..cropped.."|t |TInterface\\Icons\\INV_Misc_Toy_10:16:16:0:0:"..cropped.."|t |TInterface\\Icons\\INV_Misc_Bag_28_Halloween:16:16:0:0:"..cropped.."|t |TInterface\\Icons\\INV_Misc_Sandbox_Spectraltiger_01:16:16:0:0:"..cropped.."|t",
						},
					},
				},
			},
		},
	},
}

	----------------------------------------------
	---- 03  OnInitialize, OnEnable, OnDisable ---
	----------------------------------------------

function KCL:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("KethoCombatLogDB", defaults, true)
	self:RefreshTableRefs()

	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshTableRefs")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshTableRefs")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshTableRefs")

	self.db.global.version = 0.95
	self.db.global.fileType = "Beta"

	ACR:RegisterOptionsTable("KethoCombatLog_Main", options.args.Main)
	ACR:RegisterOptionsTable("KethoCombatLog_Advanced", options.args.Advanced)
	ACR:RegisterOptionsTable("KethoCombatLog_LibSink", self:GetSinkAce3OptionsDataTable())
	ACR:RegisterOptionsTable("KethoCombatLog_Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))

	local Main = "Ketho |cffFFFFFFCombatLog|r"
	optionsFrame = ACD:AddToBlizOptions("KethoCombatLog_Main", Main)
	ACD:AddToBlizOptions("KethoCombatLog_Advanced", "|TInterface\\Icons\\Trade_Engineering:16:16:1:0:"..cropped.."|t  "..ADVANCED, Main)
	ACD:AddToBlizOptions("KethoCombatLog_LibSink", "|TINTERFACE\\ICONS\\inv_scroll_03:16:16:1:0:"..cropped.."|t  LibSink", Main)
	ACD:AddToBlizOptions("KethoCombatLog_Profiles", "|TInterface\\Icons\\INV_Misc_Note_01:16:16:1:0:"..cropped.."|t  Profiles", Main)

	self:RegisterChatCommand("kcl", "SlashCommand")
	self:RegisterChatCommand("ket", "SlashCommand")
	self:RegisterChatCommand("ketho", "SlashCommand")
	self:RegisterChatCommand("kethocombat", "SlashCommand")
	self:RegisterChatCommand("kethocombatlog", "SlashCommand")

	if not profile.enableAddOn then
		-- Turn AddOn off again
		self:Disable()
	end
end

function KCL:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("ADDON_LOADED") -- Check for Blizzard CombatLog
end

function KCL:OnDisable()
	self:UnregisterAllEvents()
	self:CancelAllTimers()
end

	------------------------------
	--- 04  Callback Functions ---
	------------------------------

function KCL:RefreshTableRefs()
	-- table reference lookup shortcuts
	profile, char = self.db.profile, self.db.char
	color = profile.color

	-- LibSink
	self:SetSinkStorage(self.db.profile)

	-- optimize for CLEU
	filterSelf, filterEverythingElse = profile.filterSelf, profile.filterEverythingElse
	filterPlayers, filterMonsters = profile.filterPlayers, profile.filterMonsters
	chatWindow, chatChannel = profile.chatWindow, profile.chatChannel
	iconSize, Timestamp = profile.iconSize, profile.Timestamp
	overkillFormat, criticalFormat = profile.overkillFormat, profile.criticalFormat
	glancingFormat, crushingFormat = profile.glancingFormat, profile.crushingFormat

	-- other
	cropped = profile.iconCropped and "64:64:4:60:4:60" or ""
	if chatWindow > 1 then
		ChatFrame = _G["ChatFrame"..chatWindow-1]
	end

	-- update color arrays
	ClassColor = {
		["DEATHKNIGHT"] = self:Dec2Hex(unpack(color.DeathKnight)),
		["DRUID"] = self:Dec2Hex(unpack(color.Druid)),
		["HUNTER"] = self:Dec2Hex(unpack(color.Hunter)),
		["MAGE"] = self:Dec2Hex(unpack(color.Mage)),
		["PALADIN"] = self:Dec2Hex(unpack(color.Paladin)),
		["PRIEST"] = self:Dec2Hex(unpack(color.Priest)),
		["ROGUE"] = self:Dec2Hex(unpack(color.Rogue)),
		["SHAMAN"] = self:Dec2Hex(unpack(color.Shaman)),
		["WARLOCK"] = self:Dec2Hex(unpack(color.Warlock)),
		["WARRIOR"] = self:Dec2Hex(unpack(color.Warrior)),
	}

	SpellSchoolColor = {
		[0x1] = self:Dec2Hex(unpack(color.Physical)),
		[0x2] = self:Dec2Hex(unpack(color.Holy)),
		[0x4] = self:Dec2Hex(unpack(color.Fire)),
		[0x8] = self:Dec2Hex(unpack(color.Nature)),
		[0x10] = self:Dec2Hex(unpack(color.Frost)),
		[0x20] = self:Dec2Hex(unpack(color.Shadow)),
		[0x40] = self:Dec2Hex(unpack(color.Arcane)),
	}

	UnitColor = {
		self:Dec2Hex(unpack(color.Friendly)),
		self:Dec2Hex(unpack(color.Hostile)),
		self:Dec2Hex(unpack(color.Unknown)),
	}
end

function KCL:OptionsDisabled()
	return not self:IsEnabled()
end

function KCL:SlashCommand(input)
	if not input or strtrim(input) == "" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame)

	elseif input == "on" or input == "enable" or input == "1" then
		if not profile.enableAddOn then
			self:Enable(); profile.enableAddOn = true; self:Print("|cffB6CA00Enabled|r")
		else
			self:Print("Already |cffB6CA00Enabled|r")
		end
		LibStub("AceConfigRegistry-3.0"):NotifyChange("KethoCombatLog_Main")
	elseif input == "off" or input == "disable" or input == "0" then
		if profile.enableAddOn then
			self:Disable(); profile.enableAddOn = false; self:Print("|cffFF2424Disabled|r")
		else
			self:Print("Already |cffFF2424Disabled|r")
		end
		LibStub("AceConfigRegistry-3.0"):NotifyChange("KethoCombatLog_Main")
	else
		print("|cff2E9AFE/ket|r: Open Options\n|cff2E9AFE/ket|r |cffB6CA00on|r: Enable AddOn\n|cff2E9AFE/ket|r |cffFF2424off|r: Disable AddOn")
	end
end

-- Blizzard CombatLog is Load-on-Demand
function KCL:ADDON_LOADED(event, addon)
	if addon == "Blizzard_CombatLog" and not profile.BlizzardCombatLog then
		COMBATLOG:UnregisterEvent("COMBAT_LOG_EVENT")
		self:UnregisterEvent("ADDON_LOADED")
	end
end

function KCL:Dec2Hex(R, G, B)
	return string.format("%02X%02X%02X", R*255, G*255, B*255)
end

-- actually only used just once for playerColor
local RAID_CLASS_COLORS = RAID_CLASS_COLORS
local function GetClassColor(class)
	return format("%02X%02X%02X", RAID_CLASS_COLORS[class].r*255, RAID_CLASS_COLORS[class].g*255, RAID_CLASS_COLORS[class].b*255)
end

local function UnitLinkColor(unitflags)
	if band(unitflags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0 then
		return UnitColor[1]
	elseif band(unitflags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
		return UnitColor[2]
	else
		return UnitColor[3]
	end
end

-- modified from Blizzard_CombatLog
local function UnitIcon(unitFlags)
	local iconBit = band(unitFlags, COMBATLOG_OBJECT_RAIDTARGET_MASK)
	if iconBit == 0 then
		return "", ""
	end
	local icon
	local iconString, braces = "", ""
	for i = 1, 8 do
		if iconBit == _G["COMBATLOG_OBJECT_RAIDTARGET"..i] then
			icon = _G["COMBATLOG_ICON_RAIDTARGET"..i]
			braces = "{"..strlower(_G["RAID_TARGET_"..i]).."}"
			break
		end
	end
	if icon then
		iconString = format(TEXT_MODE_A_STRING_SOURCE_ICON, iconBit, icon)
	end
	return iconString, braces
end

local function SpellSchool(value)
	local str = SpellSchoolString[value] or STRING_SCHOOL_UNKNOWN.." ("..value..")"
	local color = SpellSchoolColor[value] or "71D5FF"
	return "|cff"..color..str.."|r", str, color
end

local function SpellInfo(spellID, spellName, spellSchool)
	local schoolNameLocal, schoolNameChat, schoolColor = SpellSchool(spellSchool)
	local spellIcon = iconSize>1 and "|T"..select(3,GetSpellInfo(spellID))..":"..iconSize..":"..iconSize..":0:0:"..cropped.."|t" or ""
	local spellLinkLocal = format("|cff%s"..TEXT_MODE_A_STRING_SPELL.."|r", schoolColor, spellID, "", "["..spellName.."]")..spellIcon
	local spellLinkChat = GetSpellLink(spellID)
	return schoolNameLocal, schoolNameChat, spellLinkLocal, spellLinkChat
end

local function ResultString(schoolNameLocal, schoolNameChat, amount, overkill, critical, glancing, crushing)
	local resultStr = ""
	local resultStringLocal, resultStringChat = "", ""

	if overkill and overkillFormat then
		resultStr = resultStr.." "..format(TEXT_MODE_A_STRING_RESULT_OVERKILLING, overkill)
	end
	if critical and criticalFormat then
		resultStr = resultStr.." "..TEXT_MODE_A_STRING_RESULT_CRITICAL
	end
	if glancing and glancingFormat then
		resultStr = resultStr.." "..TEXT_MODE_A_STRING_RESULT_GLANCING 
	end
	if crushing and crushingFormat then
		resultStr = resultStr.." "..TEXT_MODE_A_STRING_RESULT_CRUSHING 
	end
	if amount then
		resultStringLocal = " "..amount.." "..schoolNameLocal..resultStr
		resultStringChat = " "..amount.." "..schoolNameChat..resultStr
	end

	return resultStringLocal, resultStringChat
end

	------------------
	--- 05  Timers ---
	------------------

local Time
local f = CreateFrame("Frame")
f:SetScript("OnUpdate", function() Time = time() end)

local instanceType, instanceTypeFilter
local chatType, channel

KCL:ScheduleRepeatingTimer(function()
	-- zone based, instead of group based "detection"
	instanceType = select(2, IsInInstance())

	if chatChannel == 2 then
		chatType = "SAY"
	elseif chatChannel == 3 then
		chatType = "YELL"
	elseif chatChannel == 4 then
		chatType = instanceType == "raid" and "RAID" or (instanceType == "party" or instanceType == "arena" or GetNumPartyMembers() > 0) and "PARTY"
	else
		chatType, channel = "CHANNEL", chatChannel-4
	end

	if (profile.PvE and (instanceType == "party" or instanceType == "raid")) or
	(profile.PvP and (instanceType == "pvp" or instanceType == "arena")) or
	(profile.World and instanceType == "none") then
		instanceTypeFilter = true
	else
		instanceTypeFilter = false
	end
end, 3)

local lastDeath
local toc = select(4, GetBuildInfo())
local playerColor = GetClassColor(player.class)

function KCL:COMBAT_LOG_EVENT_UNFILTERED(event, ...)

	-----------------------
	--- Base Parameters ---
	-----------------------

	-- assigning all parameters for clarity
	local timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags
	local spellID, spellName, spellSchool
	local SuffixParam1, SuffixParam2, SuffixParam3, SuffixParam4, SuffixParam5, SuffixParam6, SuffixParam7, SuffixParam8, SuffixParam9
	
	local sourceIcon, destIcon
	local sourceIconChat, destIconChat

	-- patch 4.2.0 forwards compatible fix
	local suffixPos
	if toc >= 40200 then
		timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
		sourceIcon, sourceIconChat = UnitIcon(sourceRaidFlags)
		destIcon, destIconChat = UnitIcon(destRaidFlags)
		suffixPos = 12
	else
		timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = ...
		sourceIcon, sourceIconChat = UnitIcon(sourceFlags)
		destIcon, destIconChat = UnitIcon(destFlags)
		suffixPos = 10
	end

	---------------
	--- Filters ---
	---------------

	if sourceName == player.name or destName == player.name then
		if not filterSelf then
			return
		end
	else
		if not filterEverythingElse then
			return
		end
	end
	
	local isDamageEvent = strfind(subevent, "DAMAGE")
	local isHealEvent = strfind(subevent, "HEAL")
	local sourceType = tonumber(strsub(sourceGUID, 5, 5))
	local destType = tonumber(strsub(destGUID, 5, 5))

	-- only want to filter against the source unit
	if (sourceType == 0 and not isDamageEvent) or (destType == 0 and isDamageEvent) then
		if not filterPlayers then
			return
		end
	else
		if not filterMonsters then
			return
		end
	end

	----------------------
	--- Unit Link/Icon ---
	----------------------
	
	local sourceNameTrim, destNameTrim = "", ""
	local sourceUnitLocal, destUnitLocal = "", ""
	local sourceUnitChat, destUnitChat = "", ""

	if sourceName then
		-- trim out realm name
		sourceNameTrim = strmatch(sourceName, "([^%-]+)%-?.*")
		local name, color = sourceNameTrim
		if sourceName == player.name then
			color, name = playerColor, UNIT_YOU_SOURCE
		elseif UnitInParty(sourceName) or UnitInRaid(sourceName) then
			color = ClassColor[select(2,UnitClass(sourceName))]
		elseif sourceType == 0 and (sourceName == UnitName("target") or sourceName == UnitName("focus")) then
			if sourceName == UnitName("target") then
				color = ClassColor[select(2,UnitClass("target"))]
			elseif sourceName == UnitName("focus") then
				color = ClassColor[select(2,UnitClass("focus"))]
			end
		else
			color = UnitLinkColor(sourceFlags)
		end
		sourceUnitLocal = format("|cff%s"..TEXT_MODE_A_STRING_SOURCE_UNIT.."|r", color, sourceIcon, sourceGUID, "["..sourceNameTrim.."]", "["..name.."]")
		sourceUnitChat = sourceIconChat.."["..sourceNameTrim.."]"
	end
	if destName then
		destNameTrim = strmatch(destName, "([^%-]+)%-?.*")
		local name, color = destNameTrim
		if destName == player.name then
			color, name = playerColor, UNIT_YOU_DEST
		elseif UnitInParty(destName) or UnitInRaid(destName) then
			color = ClassColor[select(2,UnitClass(destName))]
		elseif destType == 0 and (destName == UnitName("target") or destName == UnitName("focus")) then
			if destName == UnitName("target") then
				color = ClassColor[select(2,UnitClass("target"))]
			elseif destName == UnitName("focus") then
				color = ClassColor[select(2,UnitClass("focus"))]
			end
		else
			color = UnitLinkColor(destFlags)
		end
		destUnitLocal = format("|cff%s"..TEXT_MODE_A_STRING_DEST_UNIT.."|r", color, destIcon, destGUID, "["..destNameTrim.."]", "["..(destName==sourceName and QUICKBUTTON_NAME_SELF or name).."]")
		destUnitChat = destIconChat.."["..destNameTrim.."]"
	end

	local schoolNameLocal, extraschoolNameLocal = "", ""
	local schoolNameChat, extraSchoolNameChat

	local spellIcon, extraSpellIcon
	local spellLinkLocal, extraSpellLinkLocal = "", ""
	local spellLinkChat, extraSpellLinkChat = "", ""

	----------------
	--- Suffixes ---
	----------------

	local prefix = strsub(subevent, 1, 5)
	if prefix == "SWING" then
		SuffixParam1, SuffixParam2, SuffixParam3, SuffixParam4, SuffixParam5, SuffixParam6, SuffixParam7, SuffixParam8, SuffixParam9 = select(suffixPos, ...)
	elseif prefix == "SPELL" or prefix == "RANGE" or prefix == "DAMAG" then
		spellID, spellName, spellSchool, SuffixParam1, SuffixParam2, SuffixParam3, SuffixParam4, SuffixParam5, SuffixParam6, SuffixParam7, SuffixParam8, SuffixParam9 = select(suffixPos, ...)

	-----------------------
	--- Spell Link/Icon ---
	-----------------------

		schoolNameLocal, schoolNameChat, spellLinkLocal, spellLinkChat = SpellInfo(spellID, spellName, spellSchool)
		if extraSpellEvent[subevent] then
			extraschoolNameLocal, extraSchoolNameChat, extraSpellLinkLocal, extraSpellLinkChat = SpellInfo(SuffixParam1, SuffixParam2, SuffixParam3)
		end
	end

	if instanceTypeFilter then

		local isTank = (UnitGroupRolesAssigned(sourceName) == "TANK")
		local textLocal, textChat

	-----------------
	--- Subevents ---
	-----------------

		-- Deaths
		if profile.Death and (Time > (cd.death or 0) or destName ~= lastDeath) then
			cd.death = Time + 0.1
			if isDamageEvent and subevent ~= "ENVIRONMENTAL_DAMAGE" and subevent ~= "DAMAGE_SHIELD_MISSED" and SuffixParam2 > 0 then
				lastDeath = destName
				if subevent == "SWING_DAMAGE" then
					textLocal = destUnitLocal.." |cff"..self:Dec2Hex(unpack(color.Death))..ACTION_UNIT_DIED.."|r "..sourceUnitLocal
					textChat = destUnitChat.." "..ACTION_UNIT_DIED.." "..sourceUnitChat
				else
					textLocal = destUnitLocal.." |cff"..self:Dec2Hex(unpack(color.Death))..ACTION_UNIT_DIED.."|r "..sourceUnitLocal..spellLinkLocal
					textChat = destUnitChat.." "..ACTION_UNIT_DIED.." "..sourceUnitChat..spellLinkChat
				end
			-- Death Prevents
			elseif subevent == "SPELL_HEAL" and (spellID == 48153 or spellID == 66235) and profile.DeathPrevent then -- Priest 48153[Guardian Spirit], Paladin 66235[Ardent Defender]
				textLocal = sourceUnitLocal..spellLinkLocal.." |cff"..self:Dec2Hex(unpack(color.Resurrection)).."healed "..destUnitLocal
				textChat = sourceUnitChat..spellLinkChat.." healed "..destUnitChat..spellLinkChat
			-- Instagibs
			elseif subevent == "SPELL_INSTAKILL" then
				textLocal = destUnitLocal.." |cff"..self:Dec2Hex(unpack(color.Death))..ACTION_UNIT_DIED.."|r "..sourceUnitLocal..spellLinkLocal
				textChat = destUnitChat.." "..ACTION_UNIT_DIED.." "..sourceUnitChat..spellLinkChat
			end
		end
		-- Taunts
		if profile.Taunt and ((profile.TankTaunt and isTank) or (not profile.TankTaunt and not isTank)) then
			if (destType == 3 or destType == 4) and Taunt[spellID] then
				if subevent == "SPELL_AURA_APPLIED" then
					textLocal = sourceUnitLocal..spellLinkLocal.." |cff"..self:Dec2Hex(unpack(color.Taunt)).."taunted|r "..destUnitLocal
					textChat = sourceUnitChat..spellLinkChat.." taunted "..destUnitChat
				end
			elseif subevent == "SPELL_CAST_SUCCESS" then
				-- AoE Taunt: Warrior 1161[Challenging Shout], Druid 5209[Challenging Roar]
				if spellID == 1161 or spellID == 5209 then
					textLocal = sourceUnitLocal..spellLinkLocal.." AoE "..GetSpellInfo(355)
					textChat = sourceUnitChat..spellLinkChat.." AoE "..GetSpellInfo(355)
				-- Pet 2649[Growl], Voidwalker 3716[Torment]
				elseif profile.PetGrowl and (destType >= 3 or destType == 4) and (spellID == 2649 or spellID == 3716) then
					textLocal = sourceUnitLocal..spellLinkLocal.." growled "..destUnitLocal
					textChat = sourceUnitChat..spellLinkChat.." growled "..destUnitChat
				end
			end
		end
		-- CC Breaker
		if profile.CC_Break and ((profile.TankBreak and isTank) or (not profile.TankBreak and not isTank)) then
			if subevent == "SPELL_AURA_BROKEN_SPELL" then -- broken by a spell
				textLocal = sourceUnitLocal..extraSpellLinkLocal.." |cff"..self:Dec2Hex(unpack(color.CC_Break))..ACTION_SPELL_AURA_BROKEN.."|r "..spellLinkLocal.." on "..destUnitLocal
				textChat = sourceUnitChat..extraSpellLinkChat.." "..ACTION_SPELL_AURA_BROKEN.." "..spellLinkChat.." on "..destUnitChat
			elseif subevent == "SPELL_AURA_BROKEN" then -- not broken by a spell; this subevent does not seem to fire for CLEU; 4.0.1 bug?
				if sourceName then
					textLocal = sourceUnitLocal.." |cff"..self:Dec2Hex(unpack(color.CC_Break))..ACTION_SPELL_AURA_BROKEN.."|r "..spellLinkLocal.." on "..destUnitLocal
					textChat = sourceUnitChat.." "..ACTION_SPELL_AURA_BROKEN.." "..spellLinkChat.." on "..destUnitChat
				else
					textLocal = spellLinkLocal.." on "..destUnitLocal.." |cff"..self:Dec2Hex(unpack(color.CC_Break)).."broken|r"
					textChat = spellLinkChat.." on "..destUnitChat.." broken"
				end
			end
		end
		-- Interrupts
		if subevent == "SPELL_INTERRUPT" and profile.Interrupt then
			textLocal = sourceUnitLocal..spellLinkLocal.." |cff"..self:Dec2Hex(unpack(color.Interrupt))..ACTION_SPELL_INTERRUPT.."|r "..destUnitLocal..extraSpellLinkLocal
			textChat = sourceUnitChat..spellLinkChat.." "..ACTION_SPELL_INTERRUPT.." "..destUnitChat..extraSpellLinkChat
			if toc >= 40200 then
				self:IneffectiveInterrupt(timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, spellSchool)
			else
				self:IneffectiveInterrupt(timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, spellSchool)
			end
		-- Dispels
		elseif subevent == "SPELL_DISPEL" and profile.Dispel then
			local dispelString
			if (band(sourceFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0 and band(destFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0) or
			(band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 and band(destFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0) then
				dispelString = ACTION_SPELL_DISPEL_DEBUFF
			else
				dispelString = ACTION_SPELL_DISPEL_BUFF
			end
			textLocal = sourceUnitLocal..spellLinkLocal.." |cff"..self:Dec2Hex(unpack(color.Dispel))..dispelString.."|r "..destUnitLocal..extraSpellLinkLocal
			textChat = sourceUnitChat..spellLinkChat.." "..dispelString.." "..destUnitChat..extraSpellLinkChat
		-- Spellsteals
		elseif subevent == "SPELL_STOLEN" and profile.Dispel then
			textLocal = sourceUnitLocal..spellLinkLocal.." |cff"..self:Dec2Hex(unpack(color.Dispel))..ACTION_SPELL_STOLEN.."|r "..destUnitLocal..extraSpellLinkLocal
			textChat = sourceUnitChat..spellLinkChat.." "..ACTION_SPELL_STOLEN.." "..destUnitChat..extraSpellLinkChat
		-- Reflects / Misses
		elseif subevent == "SPELL_MISSED" then
			if SuffixParam1 == "REFLECT" then
				if profile.Reflect then
					textLocal = destUnitLocal.." |cff"..self:Dec2Hex(unpack(color.Reflect))..ACTION_SPELL_MISSED_REFLECT.."|r "..sourceUnitLocal..spellLinkLocal
					textChat = destUnitChat.." "..ACTION_SPELL_MISSED_REFLECT.." "..sourceUnitChat..spellLinkChat
				end
			elseif (profile.MissTaunt and profile.Taunt and Taunt[spellID]) or
			(profile.MissInterrupt and profile.Interrupt and Interrupt[spellID]) or
			(profile.MissCC and profile.CrowdControl and CrowdControl[spellID]) or profile.MissAll then
				textLocal = sourceUnitLocal..spellLinkLocal.." on "..destUnitLocal.." |cffFF7800"..ACTION_SPELL_CAST_FAILED.."|r ("..missType[SuffixParam1]..")"
				textChat = sourceUnitChat..spellLinkChat.."  on "..destUnitChat.." "..ACTION_SPELL_CAST_FAILED.." ("..missType[SuffixParam1]..")"
				if profile.WastedInterrupt and Interrupt[spellID] then
					if toc >= 40200 then
						self:IneffectiveInterrupt(timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, spellSchool)
					else
						self:IneffectiveInterrupt(timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, spellSchool)
					end
				end
			end
		-- Resurrections
		elseif subevent == "SPELL_RESURRECT" and profile.Resurrection then
			textLocal = sourceUnitLocal..spellLinkLocal.." |cff"..self:Dec2Hex(unpack(color.Resurrection))..ACTION_SPELL_RESURRECT.."|r "..destUnitLocal
			textChat = sourceUnitChat..spellLinkChat.." "..ACTION_SPELL_RESURRECT.." "..destUnitChat
		-- Crowd Control
		elseif subevent == "SPELL_AURA_APPLIED" and profile.CrowdControl and CrowdControl[spellID] then
			textLocal = sourceUnitLocal..spellLinkLocal.." |cff"..self:Dec2Hex(unpack(color.CrowdControl)).."CC'ed|r "..destUnitLocal
			textChat = sourceUnitChat..spellLinkChat.." CC'ed "..destUnitChat
		-- Wasted Interrupt
		elseif subevent == "SPELL_CAST_SUCCESS" and profile.WastedInterrupt and SimpleInterrupt[spellID] then
			if toc >= 40200 then
				self:IneffectiveInterrupt(timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, spellSchool)
			else
				self:IneffectiveInterrupt(timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, spellSchool)
			end
		elseif subevent == "SPELL_INEFFECTIVE_INTERRUPT" then
			textLocal = sourceUnitLocal.." wasted "..spellLinkLocal.."  on "..destUnitLocal
			textChat = sourceUnitChat.." wasted "..spellLinkChat.." on "..destUnitChat
		end
		

	--[[
		-- Feast, Repair Bot, Fun
		if profile.Feast then
			if subevent == "SPELL_CREATE" and
			(spellID == 87644 or -- [Seafood Magnifique Feast]
			spellID == 87643 or -- [Broiled Dragon Feast]
			spellID == 87915 or -- [Goblin Barbecue Feast]
			spellID == 57426 or -- [Fish Feast]
			spellID == 57301 or -- [Great Feast]
			spellID == 56245 or -- [Chocolate Celebration Cake]
			spellID == 57301) then -- [Lovely Cake]
				local timeBG = GetBattlefieldInstanceRunTime()
				if instanceType == "pvp" and timeBG ~= 0 and timeBG < 130000 then text = "["..sourceNameTrim.."] prepared a "..spellLinkChat
				else
					textLocal = sourceUnitLocal.." prepared a "..spellLinkLocal
					textChat = timestampChat..sourceIconChat.."["..sourceNameTrim.."] prepared a "..spellLinkChat
				end
			end
		end
		if profile.RepairBot then
			if (subevent == "SPELL_CREATE" and spellID == 51710) or
			(subevent == "SPELL_SUMMON" and spellID == 67826 or spellID == 54711) then
				textLocal = sourceUnitLocal.." used "..spellLinkLocal
				textChat = timestampChat..sourceIconChat.."["..sourceNameTrim.."] used "..spellLinkChat
			end
		end
		if profile.Fun and player.name ~= sourceName then -- dont show yourself xD
			if (subevent == "SPELL_CAST_START" and spellID == 58493) or -- S 58493[Mohawked!]
			(subevent == "SPELL_AURA_APPLIED" and
			(spellID == 61834 or -- [Manabonked!] (NPC)
			spellID == 61819 or -- [Manabonked!] (Item)
			spellID == 60122 or -- [Baby Spice]
			((spellID == 55346 or -- [Dark Jade Beam]
			spellID == 56190 or -- [Shadow Crystal Focusing Lens]
			spellID == 56191) and destName ~= sourceName) or -- [Shadow Jade Focusing Lens]
			strfind(spellName, "Costume") or
			spellID == 27571 or -- [Cascade of Roses]  Love is in the Air
			spellID == 61815 or -- [Sprung!]  Noblegarden
			spellID == 44212 or -- [Jack-o'-Lanterned!]  Hallow's End
			spellID == 61781 or -- [Turkey Feathers]  Pilgrim's Bounty
			spellID == 44755)) or -- [Snowflakes]  Feast of Winter Veil
			(subevent == "SPELL_CREATE" and
			(spellID == 61031 or -- [Toy Train Set]
			spellID == 49844 or -- [Using Direbrew's Remote]
			spellID == 43808 or -- [Brewfest Pony Keg]
			spellID == 62857)) then -- [Sandbox Tiger]
				if spellID == 61031 or spellID == 49844 then text = "["..sourceNameTrim.."] used "..spellLinkChat -- Toy Train, Direbrew's Remote
				else
					if destName then a = " on "..destUnitLocal else a = "" end text = sourceUnitLocal.." used "..spellLinkLocal..a
				end
			end
		end
		-- Class Ability
		if subevent == "SPELL_AURA_APPLIED" then
			if ((profile.abilityExcludeSelf and sourceName ~= player.name) or not profile.abilityExcludeSelf) and
			((spellID == 20707 and profile.abilitySoulstone) or
			(spellID == 54646 and profile.abilityFocusMagic) or
			(spellID == 50720 and profile.abilityVigilance) or
			(spellID == 29166 and profile.abilityInnervate) or
			(spellID == 6346 and profile.abilityFearWard) or
			(spellID == 2096 and profile.abilityMindVision and destName ~= sourceName)) then
				textLocal = sourceUnitLocal.." cast "..spellLinkLocal.." on "..destUnitLocal
				if spellID ~= 2096 then text = timestampChat..sourceIconChat.."["..sourceNameTrim.."] cast "..spellLinkChat.." on "..destUnitChat
			end
		-- quick and dirty [Misdirection] and [Tricks of the Trade] fix
		elseif subevent == "SPELL_CAST_SUCCESS" then
			if ((profile.abilityExcludeSelf and sourceName ~= player.name) or not profile.abilityExcludeSelf) and
				((spellID == 34477 and profile.abilityMisdirection and destName ~= sourceName) or
				(spellID == 57934 and profile.abilityTricksTrade and destName ~= sourceName)) then
				textLocal = sourceUnitLocal.." cast "..spellLinkLocal.." on "..destUnitLocal
				if spellID ~= 2096 then text = timestampChat..sourceIconChat.."["..sourceNameTrim.."] cast "..spellLinkChat.." on "..destUnitChat
			end
		end
		if subevent == "SPELL_CAST_SUCCESS" then
			if profile.abilityBloodlust and ((spellID == 32182 or spellID == 2825 or spellID == 80353) and Time > (cd.Bloodlust or 0)) or
			(spellID == 43987 and profile.abilityRitualRefreshment and Time > (cd.RitualRefreshment or 0)) then
				if spellID == 32182 or spellID == 2825 or spellID == 80353 then cd.Bloodlust = Time + 130 -- set cooldowns
				elseif spellID == 43987 then cd.RitualRefreshment = Time + 130 end
				local timeBG = GetBattlefieldInstanceRunTime()
				if instanceType == "pvp" and timeBG ~= 0 and timeBG < 130000 then text = "["..sourceNameTrim.."] cast "..spellLinkChat -- Heroism/Bloodlust/Timewarp "wasted" before bg starts; Ritual of Refreshment
					chatType = "BATTLEGROUND"
				else
					textLocal = sourceUnitLocal.." cast "..spellLinkLocal
					textChat = timestampChat..sourceIconChat.."["..sourceNameTrim.."] cast "..spellLinkChat
				end
			end
		end
	]]

		if textLocal then
			local timestampLocal, timestampChat = "", ""
			if Timestamp then
				local Date = date("[%H:%M:%S]")
				timestampLocal = "|cffA9A9A9"..Date.."|r "
				timestampChat = Date.." "
			end

			local resultStringLocal, resultStringChat = "", ""
			if isDamageEvent or isHealEvent then
				if subevent == "SWING_DAMAGE" then
					schoolNameLocal = "|cff"..self:Dec2Hex(unpack(color.Physical))..ACTION_SWING.."|r"
					schoolNameChat = ACTION_SWING
				end
				resultStringLocal, resultStringChat = ResultString(schoolNameLocal, schoolNameChat, SuffixParam1, SuffixParam2, SuffixParam7, SuffixParam8, SuffixParam9)
			end

			textLocal = timestampLocal..textLocal..resultStringLocal
			textChat = timestampChat..textChat..resultStringChat

	--------------
	--- Output ---
	--------------

			if chatWindow > 1 then
				ChatFrame:AddMessage(textLocal)
			end
			if chatChannel > 1 then
				SendChatMessage(textChat, chatType, nil, channel)
			end
			if profile.sink20OutputSink == "Channel" then
				self:Pour(textChat)
			else
				self:Pour(textLocal)
			end
		end
	end
end

-- this is kinda ugly and wonky; especially with patch 4.2 forwards compatibility
function KCL:IneffectiveInterrupt(...)
	local timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, spellSchool

	local sourceGUID = select(4, ...)
	InterruptCheck[sourceGUID] = InterruptCheck[sourceGUID] or {}
	InterruptCheck[sourceGUID][Time] = InterruptCheck[sourceGUID][Time] or {}
	local entry = InterruptCheck[sourceGUID][Time]

	if toc >= 40200 then
		timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, spellSchool = ...
		if subevent == "SPELL_CAST_SUCCESS" then
			entry[2] = spellID
			self:ScheduleTimer(function() self:IneffectiveInterrupt(timestamp, "CHECK_INEFFECTIVE_INTERRUPT", hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, spellSchool) end, 0.1)
		elseif subevent == "SPELL_INTERRUPT" or subevent == "SPELL_MISSED" then
			entry[1] = true
		elseif subevent == "CHECK_INEFFECTIVE_INTERRUPT" then
			if not entry[1] and entry[2] == spellID then
				self:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, "SPELL_INEFFECTIVE_INTERRUPT", hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, spellSchool)
			end
		end
	else
		timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, spellSchool = ...
		if subevent == "SPELL_CAST_SUCCESS" then
			entry[2] = spellID
			self:ScheduleTimer(function() self:IneffectiveInterrupt(timestamp, "CHECK_INEFFECTIVE_INTERRUPT", hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, spellSchool) end, 0.1)
		elseif subevent == "SPELL_INTERRUPT" or subevent == "SPELL_MISSED"  then
			entry[1] = true
		elseif subevent == "CHECK_INEFFECTIVE_INTERRUPT" then
			if not entry[1] and entry[2] == spellID then
				self:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, "SPELL_INEFFECTIVE_INTERRUPT", hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, spellSchool)
			end
		end
	end
end